Index: trunk/LMDZ.COMMON/libf/bibio/nf95_gw_var_m.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/bibio/nf95_gw_var_m.F90	(revision 617)
+++ trunk/LMDZ.COMMON/libf/bibio/nf95_gw_var_m.F90	(revision 776)
@@ -1,4 +1,7 @@
 ! $Id$
 module nf95_gw_var_m
+
+  use nf95_get_var_m, only: NF95_GET_VAR
+  use simple, only: nf95_inquire_variable, nf95_inquire_dimension
 
   implicit none
@@ -8,14 +11,14 @@
      ! These procedures read a whole NetCDF variable (coordinate or
      ! primary) into an array.
-     ! The difference between the procedures is the rank of the array
-     ! and the type of Fortran values.
+     ! The difference between the procedures is the rank and type of
+     ! argument "values".
      ! The procedures do not check the type of the NetCDF variable.
 
-!!$     module procedure nf95_gw_var_real_1d, nf95_gw_var_real_2d, &
-!!$          nf95_gw_var_real_3d, nf95_gw_var_real_4d, nf95_gw_var_dble_1d, &
-!!$          nf95_gw_var_dble_3d, nf95_gw_var_int_1d, nf95_gw_var_int_3d
+     ! Not including double precision procedures in the generic
+     ! interface because we use a compilation option that changes default
+     ! real precision.
      module procedure nf95_gw_var_real_1d, nf95_gw_var_real_2d, &
-          nf95_gw_var_real_3d, nf95_gw_var_real_4d, nf95_gw_var_int_1d, &
-          nf95_gw_var_int_3d
+          nf95_gw_var_real_3d, nf95_gw_var_real_4d, nf95_gw_var_real_5d, &
+          nf95_gw_var_int_1d, nf95_gw_var_int_3d
   end interface
 
@@ -29,8 +32,4 @@
     ! Real type, the array has rank 1.
 
-    use netcdf, only: NF90_GET_VAR
-    use simple, only: nf95_inquire_variable, nf95_inquire_dimension
-    use handle_err_m, only: handle_err
-
     integer, intent(in):: ncid
     integer, intent(in):: varid
@@ -38,6 +37,6 @@
 
     ! Variables local to the procedure:
-    integer ierr, len
-    integer, pointer :: dimids(:)
+    integer nclen
+    integer, pointer:: dimids(:)
 
     !---------------------
@@ -46,16 +45,15 @@
 
     if (size(dimids) /= 1) then
-       print *, "nf95_gw_var_real_1d: NetCDF variable is not of rank 1"
-       stop 1
-    end if
-
-    call nf95_inquire_dimension(ncid, dimids(1), len=len)
-    deallocate(dimids) ! pointer
-
-    allocate(values(len))
-    if (len /= 0) then
-       ierr = NF90_GET_VAR(ncid, varid, values)
-       call handle_err("NF90_GET_VAR", ierr, ncid, varid)
-    end if
+       print *, "nf95_gw_var_real_1d:"
+       print *, "varid = ", varid
+       print *, "rank of NetCDF variable is ", size(dimids), ", not 1"
+       stop 1
+    end if
+
+    call nf95_inquire_dimension(ncid, dimids(1), nclen=nclen)
+    deallocate(dimids) ! pointer
+
+    allocate(values(nclen))
+    if (nclen /= 0) call NF95_GET_VAR(ncid, varid, values)
 
   end subroutine nf95_gw_var_real_1d
@@ -67,8 +65,4 @@
     ! Real type, the array has rank 2.
 
-    use netcdf, only: NF90_GET_VAR
-    use simple, only: nf95_inquire_variable, nf95_inquire_dimension
-    use handle_err_m, only: handle_err
-
     integer, intent(in):: ncid
     integer, intent(in):: varid
@@ -76,6 +70,6 @@
 
     ! Variables local to the procedure:
-    integer ierr, len1, len2
-    integer, pointer :: dimids(:)
+    integer nclen1, nclen2
+    integer, pointer:: dimids(:)
 
     !---------------------
@@ -84,17 +78,16 @@
 
     if (size(dimids) /= 2) then
-       print *, "nf95_gw_var_real_2d: NetCDF variable is not of rank 2"
-       stop 1
-    end if
-
-    call nf95_inquire_dimension(ncid, dimids(1), len=len1)
-    call nf95_inquire_dimension(ncid, dimids(2), len=len2)
-    deallocate(dimids) ! pointer
-
-    allocate(values(len1, len2))
-    if (len1 /= 0 .and. len2 /= 0) then
-       ierr = NF90_GET_VAR(ncid, varid, values)
-       call handle_err("NF90_GET_VAR", ierr, ncid, varid)
-    end if
+       print *, "nf95_gw_var_real_2d:"
+       print *, "varid = ", varid
+       print *, "rank of NetCDF variable is ", size(dimids), ", not 2"
+       stop 1
+    end if
+
+    call nf95_inquire_dimension(ncid, dimids(1), nclen=nclen1)
+    call nf95_inquire_dimension(ncid, dimids(2), nclen=nclen2)
+    deallocate(dimids) ! pointer
+
+    allocate(values(nclen1, nclen2))
+    if (nclen1 /= 0 .and. nclen2 /= 0) call NF95_GET_VAR(ncid, varid, values)
 
   end subroutine nf95_gw_var_real_2d
@@ -106,8 +99,4 @@
     ! Real type, the array has rank 3.
 
-    use netcdf, only: NF90_GET_VAR
-    use simple, only: nf95_inquire_variable, nf95_inquire_dimension
-    use handle_err_m, only: handle_err
-
     integer, intent(in):: ncid
     integer, intent(in):: varid
@@ -115,6 +104,6 @@
 
     ! Variables local to the procedure:
-    integer ierr, len1, len2, len3
-    integer, pointer :: dimids(:)
+    integer nclen1, nclen2, nclen3
+    integer, pointer:: dimids(:)
 
     !---------------------
@@ -123,18 +112,17 @@
 
     if (size(dimids) /= 3) then
-       print *, "nf95_gw_var_real_3d: NetCDF variable is not of rank 3"
-       stop 1
-    end if
-
-    call nf95_inquire_dimension(ncid, dimids(1), len=len1)
-    call nf95_inquire_dimension(ncid, dimids(2), len=len2)
-    call nf95_inquire_dimension(ncid, dimids(3), len=len3)
-    deallocate(dimids) ! pointer
-
-    allocate(values(len1, len2, len3))
-    if (len1 * len2 * len3 /= 0) then
-       ierr = NF90_GET_VAR(ncid, varid, values)
-       call handle_err("NF90_GET_VAR", ierr, ncid, varid)
-    end if
+       print *, "nf95_gw_var_real_3d:"
+       print *, "varid = ", varid
+       print *, "rank of NetCDF variable is ", size(dimids), ", not 3"
+       stop 1
+    end if
+
+    call nf95_inquire_dimension(ncid, dimids(1), nclen=nclen1)
+    call nf95_inquire_dimension(ncid, dimids(2), nclen=nclen2)
+    call nf95_inquire_dimension(ncid, dimids(3), nclen=nclen3)
+    deallocate(dimids) ! pointer
+
+    allocate(values(nclen1, nclen2, nclen3))
+    if (nclen1 * nclen2 * nclen3 /= 0) call NF95_GET_VAR(ncid, varid, values)
 
   end subroutine nf95_gw_var_real_3d
@@ -146,8 +134,4 @@
     ! Real type, the array has rank 4.
 
-    use netcdf, only: NF90_GET_VAR
-    use simple, only: nf95_inquire_variable, nf95_inquire_dimension
-    use handle_err_m, only: handle_err
-
     integer, intent(in):: ncid
     integer, intent(in):: varid
@@ -155,6 +139,6 @@
 
     ! Variables local to the procedure:
-    integer ierr, len_dim(4), i
-    integer, pointer :: dimids(:)
+    integer len_dim(4), i
+    integer, pointer:: dimids(:)
 
     !---------------------
@@ -163,18 +147,17 @@
 
     if (size(dimids) /= 4) then
-       print *, "nf95_gw_var_real_4d: NetCDF variable is not of rank 4"
+       print *, "nf95_gw_var_real_4d:"
+       print *, "varid = ", varid
+       print *, "rank of NetCDF variable is ", size(dimids), ", not 4"
        stop 1
     end if
 
     do i = 1, 4
-       call nf95_inquire_dimension(ncid, dimids(i), len=len_dim(i))
+       call nf95_inquire_dimension(ncid, dimids(i), nclen=len_dim(i))
     end do
     deallocate(dimids) ! pointer
 
     allocate(values(len_dim(1), len_dim(2), len_dim(3), len_dim(4)))
-    if (all(len_dim /= 0)) then
-       ierr = NF90_GET_VAR(ncid, varid, values)
-       call handle_err("NF90_GET_VAR", ierr, ncid, varid)
-    end if
+    if (all(len_dim /= 0)) call NF95_GET_VAR(ncid, varid, values)
 
   end subroutine nf95_gw_var_real_4d
@@ -182,11 +165,42 @@
   !************************************
 
+  subroutine nf95_gw_var_real_5d(ncid, varid, values)
+
+    ! Real type, the array has rank 5.
+
+    integer, intent(in):: ncid
+    integer, intent(in):: varid
+    real, pointer:: values(:, :, :, :, :)
+
+    ! Variables local to the procedure:
+    integer len_dim(5), i
+    integer, pointer:: dimids(:)
+
+    !---------------------
+
+    call nf95_inquire_variable(ncid, varid, dimids=dimids)
+
+    if (size(dimids) /= 5) then
+       print *, "nf95_gw_var_real_5d:"
+       print *, "varid = ", varid
+       print *, "rank of NetCDF variable is ", size(dimids), ", not 5"
+       stop 1
+    end if
+
+    do i = 1, 5
+       call nf95_inquire_dimension(ncid, dimids(i), nclen=len_dim(i))
+    end do
+    deallocate(dimids) ! pointer
+
+    allocate(values(len_dim(1), len_dim(2), len_dim(3), len_dim(4), len_dim(5)))
+    if (all(len_dim /= 0)) call NF95_GET_VAR(ncid, varid, values)
+
+  end subroutine nf95_gw_var_real_5d
+
+  !************************************
+
 !!$  subroutine nf95_gw_var_dble_1d(ncid, varid, values)
 !!$
 !!$    ! Double precision, the array has rank 1.
-!!$
-!!$    use netcdf, only: NF90_GET_VAR
-!!$    use simple, only: nf95_inquire_variable, nf95_inquire_dimension
-!!$    use handle_err_m, only: handle_err
 !!$
 !!$    integer, intent(in):: ncid
@@ -195,6 +209,6 @@
 !!$
 !!$    ! Variables local to the procedure:
-!!$    integer ierr, len
-!!$    integer, pointer :: dimids(:)
+!!$    integer nclen
+!!$    integer, pointer:: dimids(:)
 !!$
 !!$    !---------------------
@@ -203,16 +217,15 @@
 !!$
 !!$    if (size(dimids) /= 1) then
-!!$       print *, "nf95_gw_var_dble_1d: NetCDF variable is not of rank 1"
-!!$       stop 1
+!!$       print *, "nf95_gw_var_dble_1d:"
+!!$       print *, "varid = ", varid
+!!$       print *, "rank of NetCDF variable is ", size(dimids), ", not 1"
+!!$        stop 1
 !!$    end if
 !!$
-!!$    call nf95_inquire_dimension(ncid, dimids(1), len=len)
+!!$    call nf95_inquire_dimension(ncid, dimids(1), nclen=nclen)
 !!$    deallocate(dimids) ! pointer
 !!$
-!!$    allocate(values(len))
-!!$    if (len /= 0) then
-!!$       ierr = NF90_GET_VAR(ncid, varid, values)
-!!$       call handle_err("NF90_GET_VAR", ierr, ncid, varid)
-!!$    end if
+!!$    allocate(values(nclen))
+!!$    if (nclen /= 0) call NF95_GET_VAR(ncid, varid, values)
 !!$
 !!$  end subroutine nf95_gw_var_dble_1d
@@ -223,8 +236,4 @@
 !!$
 !!$    ! Double precision, the array has rank 3.
-!!$
-!!$    use netcdf, only: NF90_GET_VAR
-!!$    use simple, only: nf95_inquire_variable, nf95_inquire_dimension
-!!$    use handle_err_m, only: handle_err
 !!$
 !!$    integer, intent(in):: ncid
@@ -233,6 +242,6 @@
 !!$
 !!$    ! Variables local to the procedure:
-!!$    integer ierr, len1, len2, len3
-!!$    integer, pointer :: dimids(:)
+!!$    integer nclen1, nclen2, nclen3
+!!$    integer, pointer:: dimids(:)
 !!$
 !!$    !---------------------
@@ -241,21 +250,20 @@
 !!$
 !!$    if (size(dimids) /= 3) then
-!!$       print *, "nf95_gw_var_dble_3d: NetCDF variable is not of rank 3"
+!!$       print *, "nf95_gw_var_dble_3d:"
+!!$       print *, "varid = ", varid
+!!$       print *, "rank of NetCDF variable is ", size(dimids), ", not 3"
 !!$       stop 1
 !!$    end if
 !!$
-!!$    call nf95_inquire_dimension(ncid, dimids(1), len=len1)
-!!$    call nf95_inquire_dimension(ncid, dimids(2), len=len2)
-!!$    call nf95_inquire_dimension(ncid, dimids(3), len=len3)
+!!$    call nf95_inquire_dimension(ncid, dimids(1), nclen=nclen1)
+!!$    call nf95_inquire_dimension(ncid, dimids(2), nclen=nclen2)
+!!$    call nf95_inquire_dimension(ncid, dimids(3), nclen=nclen3)
 !!$    deallocate(dimids) ! pointer
 !!$
-!!$    allocate(values(len1, len2, len3))
-!!$    if (len1 * len2 * len3 /= 0) then
-!!$       ierr = NF90_GET_VAR(ncid, varid, values)
-!!$       call handle_err("NF90_GET_VAR", ierr, ncid, varid)
-!!$    end if
+!!$    allocate(values(nclen1, nclen2, nclen3))
+!!$    if (nclen1 * nclen2 * nclen3 /= 0) call NF95_GET_VAR(ncid, varid, values)
 !!$
 !!$  end subroutine nf95_gw_var_dble_3d
-
+!!$
   !************************************
 
@@ -264,8 +272,4 @@
     ! Integer type, the array has rank 1.
 
-    use netcdf, only: NF90_GET_VAR
-    use simple, only: nf95_inquire_variable, nf95_inquire_dimension
-    use handle_err_m, only: handle_err
-
     integer, intent(in):: ncid
     integer, intent(in):: varid
@@ -273,6 +277,6 @@
 
     ! Variables local to the procedure:
-    integer ierr, len
-    integer, pointer :: dimids(:)
+    integer nclen
+    integer, pointer:: dimids(:)
 
     !---------------------
@@ -281,16 +285,15 @@
 
     if (size(dimids) /= 1) then
-       print *, "nf95_gw_var_int_1d: NetCDF variable is not of rank 1"
-       stop 1
-    end if
-
-    call nf95_inquire_dimension(ncid, dimids(1), len=len)
-    deallocate(dimids) ! pointer
-
-    allocate(values(len))
-    if (len /= 0) then
-       ierr = NF90_GET_VAR(ncid, varid, values)
-       call handle_err("NF90_GET_VAR", ierr, ncid, varid)
-    end if
+       print *, "nf95_gw_var_int_1d:"
+       print *, "varid = ", varid
+       print *, "rank of NetCDF variable is ", size(dimids), ", not 1"
+       stop 1
+    end if
+
+    call nf95_inquire_dimension(ncid, dimids(1), nclen=nclen)
+    deallocate(dimids) ! pointer
+
+    allocate(values(nclen))
+    if (nclen /= 0) call NF95_GET_VAR(ncid, varid, values)
 
   end subroutine nf95_gw_var_int_1d
@@ -302,8 +305,4 @@
     ! Integer type, the array has rank 3.
 
-    use netcdf, only: NF90_GET_VAR
-    use simple, only: nf95_inquire_variable, nf95_inquire_dimension
-    use handle_err_m, only: handle_err
-
     integer, intent(in):: ncid
     integer, intent(in):: varid
@@ -311,6 +310,6 @@
 
     ! Variables local to the procedure:
-    integer ierr, len1, len2, len3
-    integer, pointer :: dimids(:)
+    integer nclen1, nclen2, nclen3
+    integer, pointer:: dimids(:)
 
     !---------------------
@@ -319,18 +318,17 @@
 
     if (size(dimids) /= 3) then
-       print *, "nf95_gw_var_int_3d: NetCDF variable is not of rank 3"
-       stop 1
-    end if
-
-    call nf95_inquire_dimension(ncid, dimids(1), len=len1)
-    call nf95_inquire_dimension(ncid, dimids(2), len=len2)
-    call nf95_inquire_dimension(ncid, dimids(3), len=len3)
-    deallocate(dimids) ! pointer
-
-    allocate(values(len1, len2, len3))
-    if (len1 * len2 * len3 /= 0) then
-       ierr = NF90_GET_VAR(ncid, varid, values)
-       call handle_err("NF90_GET_VAR", ierr, ncid, varid)
-    end if
+       print *, "nf95_gw_var_int_3d:"
+       print *, "varid = ", varid
+       print *, "rank of NetCDF variable is ", size(dimids), ", not 3"
+       stop 1
+    end if
+
+    call nf95_inquire_dimension(ncid, dimids(1), nclen=nclen1)
+    call nf95_inquire_dimension(ncid, dimids(2), nclen=nclen2)
+    call nf95_inquire_dimension(ncid, dimids(3), nclen=nclen3)
+    deallocate(dimids) ! pointer
+
+    allocate(values(nclen1, nclen2, nclen3))
+    if (nclen1 * nclen2 * nclen3 /= 0) call NF95_GET_VAR(ncid, varid, values)
 
   end subroutine nf95_gw_var_int_3d
Index: trunk/LMDZ.COMMON/libf/bibio/nf95_put_var_m.F90
===================================================================
--- trunk/LMDZ.COMMON/libf/bibio/nf95_put_var_m.F90	(revision 617)
+++ trunk/LMDZ.COMMON/libf/bibio/nf95_put_var_m.F90	(revision 776)
@@ -9,8 +9,4 @@
           nf95_put_var_2D_FourByteReal, nf95_put_var_3D_FourByteReal, &
           nf95_put_var_4D_FourByteReal
-!!$     module procedure nf95_put_var_1D_FourByteReal, &
-!!$          nf95_put_var_2D_FourByteReal, nf95_put_var_3D_FourByteReal, &
-!!$          nf95_put_var_4D_FourByteReal, nf90_put_var_1D_EightByteReal, &
-!!$          nf90_put_var_3D_EightByteReal
   end interface
 
@@ -25,7 +21,7 @@
     use handle_err_m, only: handle_err
 
-    integer, intent( in) :: ncid, varid
-    real, intent( in) :: values
-    integer, dimension(:), optional, intent( in) :: start
+    integer, intent(in) :: ncid, varid
+    real, intent(in) :: values
+    integer, dimension(:), optional, intent(in) :: start
     integer, intent(out), optional:: ncerr
 
@@ -52,7 +48,7 @@
     use handle_err_m, only: handle_err
 
-    integer, intent( in) :: ncid, varid
-    integer, intent( in) :: values
-    integer, dimension(:), optional, intent( in) :: start
+    integer, intent(in) :: ncid, varid
+    integer, intent(in) :: values
+    integer, dimension(:), optional, intent(in) :: start
     integer, intent(out), optional:: ncerr
 
@@ -74,6 +70,6 @@
   !***********************
 
-  subroutine nf95_put_var_1D_FourByteReal(ncid, varid, values, start, count, &
-       stride, map, ncerr)
+  subroutine nf95_put_var_1D_FourByteReal(ncid, varid, values, start, &
+       count_nc, stride, map, ncerr)
 
     use netcdf, only: nf90_put_var
@@ -82,14 +78,14 @@
     integer,                         intent(in) :: ncid, varid
     real, intent(in) :: values(:)
-    integer, dimension(:), optional, intent(in) :: start, count, stride, map
-    integer, intent(out), optional:: ncerr
-
-    ! Variable local to the procedure:
-    integer ncerr_not_opt
-
-    !-------------------
-
-    ncerr_not_opt = nf90_put_var(ncid, varid, values, start, count, stride, &
-         map)
+    integer, dimension(:), optional, intent(in) :: start, count_nc, stride, map
+    integer, intent(out), optional:: ncerr
+
+    ! Variable local to the procedure:
+    integer ncerr_not_opt
+
+    !-------------------
+
+    ncerr_not_opt = nf90_put_var(ncid, varid, values, start, count_nc, &
+         stride, map)
     if (present(ncerr)) then
        ncerr = ncerr_not_opt
@@ -103,6 +99,6 @@
   !***********************
 
-  subroutine nf95_put_var_1D_FourByteInt(ncid, varid, values, start, count, &
-       stride, map, ncerr)
+  subroutine nf95_put_var_1D_FourByteInt(ncid, varid, values, start, &
+       count_nc, stride, map, ncerr)
 
     use netcdf, only: nf90_put_var
@@ -111,14 +107,14 @@
     integer,                         intent(in) :: ncid, varid
     integer, intent(in) :: values(:)
-    integer, dimension(:), optional, intent(in) :: start, count, stride, map
-    integer, intent(out), optional:: ncerr
-
-    ! Variable local to the procedure:
-    integer ncerr_not_opt
-
-    !-------------------
-
-    ncerr_not_opt = nf90_put_var(ncid, varid, values, start, count, stride, &
-         map)
+    integer, dimension(:), optional, intent(in) :: start, count_nc, stride, map
+    integer, intent(out), optional:: ncerr
+
+    ! Variable local to the procedure:
+    integer ncerr_not_opt
+
+    !-------------------
+
+    ncerr_not_opt = nf90_put_var(ncid, varid, values, start, count_nc, &
+         stride, map)
     if (present(ncerr)) then
        ncerr = ncerr_not_opt
@@ -132,22 +128,52 @@
   !***********************
 
-  subroutine nf95_put_var_2D_FourByteReal(ncid, varid, values, start, count, &
-       stride, map, ncerr)
-
-    use netcdf, only: nf90_put_var
-    use handle_err_m, only: handle_err
-
-    integer,                         intent( in) :: ncid, varid
-    real, intent( in) :: values(:, :)
-    integer, dimension(:), optional, intent( in) :: start, count, stride, map
-    integer, intent(out), optional:: ncerr
-
-    ! Variable local to the procedure:
-    integer ncerr_not_opt
-
-    !-------------------
-
-    ncerr_not_opt = nf90_put_var(ncid, varid, values, start, count, stride, &
-         map)
+  subroutine nf95_put_var_1D_EightByteReal(ncid, varid, values, start, &
+       count_nc, stride, map, ncerr)
+
+    use typesizes, only: eightByteReal
+    use netcdf, only: nf90_put_var
+    use handle_err_m, only: handle_err
+
+    integer,                         intent(in) :: ncid, varid
+    real (kind = EightByteReal),     intent(in) :: values(:)
+    integer, dimension(:), optional, intent(in):: start, count_nc, stride, map
+    integer, intent(out), optional:: ncerr
+
+    ! Variable local to the procedure:
+    integer ncerr_not_opt
+
+    !-------------------
+
+    ncerr_not_opt = nf90_put_var(ncid, varid, values, start, count_nc, &
+         stride, map)
+    if (present(ncerr)) then
+       ncerr = ncerr_not_opt
+    else
+       call handle_err("nf95_put_var_1D_eightByteReal", ncerr_not_opt, ncid, &
+            varid)
+    end if
+
+  end subroutine nf95_put_var_1D_EightByteReal
+
+  !***********************
+
+  subroutine nf95_put_var_2D_FourByteReal(ncid, varid, values, start, &
+       count_nc, stride, map, ncerr)
+
+    use netcdf, only: nf90_put_var
+    use handle_err_m, only: handle_err
+
+    integer,                         intent(in) :: ncid, varid
+    real, intent(in) :: values(:, :)
+    integer, dimension(:), optional, intent(in) :: start, count_nc, stride, map
+    integer, intent(out), optional:: ncerr
+
+    ! Variable local to the procedure:
+    integer ncerr_not_opt
+
+    !-------------------
+
+    ncerr_not_opt = nf90_put_var(ncid, varid, values, start, count_nc, &
+         stride, map)
     if (present(ncerr)) then
        ncerr = ncerr_not_opt
@@ -161,22 +187,52 @@
   !***********************
 
-  subroutine nf95_put_var_3D_FourByteReal(ncid, varid, values, start, count, &
-       stride, map, ncerr)
-
-    use netcdf, only: nf90_put_var
-    use handle_err_m, only: handle_err
-
-    integer,                         intent( in) :: ncid, varid
-    real, intent( in) :: values(:, :, :)
-    integer, dimension(:), optional, intent( in) :: start, count, stride, map
-    integer, intent(out), optional:: ncerr
-
-    ! Variable local to the procedure:
-    integer ncerr_not_opt
-
-    !-------------------
-
-    ncerr_not_opt = nf90_put_var(ncid, varid, values, start, count, stride, &
-         map)
+  subroutine nf95_put_var_2D_EightByteReal(ncid, varid, values, start, &
+       count_nc, stride, map, ncerr)
+
+    use typesizes, only: EightByteReal
+    use netcdf, only: nf90_put_var
+    use handle_err_m, only: handle_err
+
+    integer,                         intent(in) :: ncid, varid
+    real (kind = EightByteReal), intent(in) :: values(:, :)
+    integer, dimension(:), optional, intent(in) :: start, count_nc, stride, map
+    integer, intent(out), optional:: ncerr
+
+    ! Variable local to the procedure:
+    integer ncerr_not_opt
+
+    !-------------------
+
+    ncerr_not_opt = nf90_put_var(ncid, varid, values, start, count_nc, &
+         stride, map)
+    if (present(ncerr)) then
+       ncerr = ncerr_not_opt
+    else
+       call handle_err("nf95_put_var_2D_EightByteReal", ncerr_not_opt, ncid, &
+            varid)
+    end if
+
+  end subroutine nf95_put_var_2D_EightByteReal
+
+  !***********************
+
+  subroutine nf95_put_var_3D_FourByteReal(ncid, varid, values, start, &
+       count_nc, stride, map, ncerr)
+
+    use netcdf, only: nf90_put_var
+    use handle_err_m, only: handle_err
+
+    integer,                         intent(in) :: ncid, varid
+    real, intent(in) :: values(:, :, :)
+    integer, dimension(:), optional, intent(in) :: start, count_nc, stride, map
+    integer, intent(out), optional:: ncerr
+
+    ! Variable local to the procedure:
+    integer ncerr_not_opt
+
+    !-------------------
+
+    ncerr_not_opt = nf90_put_var(ncid, varid, values, start, count_nc, &
+         stride, map)
     if (present(ncerr)) then
        ncerr = ncerr_not_opt
@@ -190,22 +246,52 @@
   !***********************
 
-  subroutine nf95_put_var_4D_FourByteReal(ncid, varid, values, start, count, &
-       stride, map, ncerr)
-
-    use netcdf, only: nf90_put_var
-    use handle_err_m, only: handle_err
-
-    integer,                         intent( in) :: ncid, varid
-    real, intent( in) :: values(:, :, :, :)
-    integer, dimension(:), optional, intent( in) :: start, count, stride, map
-    integer, intent(out), optional:: ncerr
-
-    ! Variable local to the procedure:
-    integer ncerr_not_opt
-
-    !-------------------
-
-    ncerr_not_opt = nf90_put_var(ncid, varid, values, start, count, stride, &
-         map)
+  subroutine nf95_put_var_3D_EightByteReal(ncid, varid, values, start, &
+       count_nc, stride, map, ncerr)
+
+    use typesizes, only: eightByteReal
+    use netcdf, only: nf90_put_var
+    use handle_err_m, only: handle_err
+
+    integer,                         intent(in) :: ncid, varid
+    real (kind = EightByteReal),     intent(in) :: values(:, :, :)
+    integer, dimension(:), optional, intent(in) :: start, count_nc, stride, map
+    integer, intent(out), optional:: ncerr
+
+    ! Variable local to the procedure:
+    integer ncerr_not_opt
+
+    !-------------------
+
+    ncerr_not_opt = nf90_put_var(ncid, varid, values, start, count_nc, &
+         stride, map)
+    if (present(ncerr)) then
+       ncerr = ncerr_not_opt
+    else
+       call handle_err("nf95_put_var_3D_eightByteReal", ncerr_not_opt, ncid, &
+            varid)
+    end if
+
+  end subroutine nf95_put_var_3D_EightByteReal
+
+  !***********************
+
+  subroutine nf95_put_var_4D_FourByteReal(ncid, varid, values, start, &
+       count_nc, stride, map, ncerr)
+
+    use netcdf, only: nf90_put_var
+    use handle_err_m, only: handle_err
+
+    integer,                         intent(in) :: ncid, varid
+    real, intent(in) :: values(:, :, :, :)
+    integer, dimension(:), optional, intent(in) :: start, count_nc, stride, map
+    integer, intent(out), optional:: ncerr
+
+    ! Variable local to the procedure:
+    integer ncerr_not_opt
+
+    !-------------------
+
+    ncerr_not_opt = nf90_put_var(ncid, varid, values, start, count_nc, &
+         stride, map)
     if (present(ncerr)) then
        ncerr = ncerr_not_opt
@@ -219,61 +305,31 @@
   !***********************
 
-!!$  subroutine nf90_put_var_1D_EightByteReal(ncid, varid, values, start, count, &
-!!$       stride, map, ncerr)
-!!$
-!!$    use typesizes, only: eightByteReal
-!!$    use netcdf, only: nf90_put_var
-!!$    use handle_err_m, only: handle_err
-!!$
-!!$    integer,                         intent( in) :: ncid, varid
-!!$    real (kind = EightByteReal),     intent( in) :: values(:)
-!!$    integer, dimension(:), optional, intent( in) :: start, count, stride, map
-!!$    integer, intent(out), optional:: ncerr
-!!$
-!!$    ! Variable local to the procedure:
-!!$    integer ncerr_not_opt
-!!$
-!!$    !-------------------
-!!$
-!!$    ncerr_not_opt = nf90_put_var(ncid, varid, values, start, count, stride, &
-!!$         map)
-!!$    if (present(ncerr)) then
-!!$       ncerr = ncerr_not_opt
-!!$    else
-!!$       call handle_err("nf95_put_var_1D_eightByteReal", ncerr_not_opt, ncid, &
-!!$            varid)
-!!$    end if
-!!$
-!!$  end subroutine nf90_put_var_1D_EightByteReal
-!!$
-!!$  !***********************
-!!$
-!!$  subroutine nf90_put_var_3D_EightByteReal(ncid, varid, values, start, count, &
-!!$       stride, map, ncerr)
-!!$
-!!$    use typesizes, only: eightByteReal
-!!$    use netcdf, only: nf90_put_var
-!!$    use handle_err_m, only: handle_err
-!!$
-!!$    integer,                         intent( in) :: ncid, varid
-!!$    real (kind = EightByteReal),     intent( in) :: values(:, :, :)
-!!$    integer, dimension(:), optional, intent( in) :: start, count, stride, map
-!!$    integer, intent(out), optional:: ncerr
-!!$
-!!$    ! Variable local to the procedure:
-!!$    integer ncerr_not_opt
-!!$
-!!$    !-------------------
-!!$
-!!$    ncerr_not_opt = nf90_put_var(ncid, varid, values, start, count, stride, &
-!!$         map)
-!!$    if (present(ncerr)) then
-!!$       ncerr = ncerr_not_opt
-!!$    else
-!!$       call handle_err("nf95_put_var_3D_eightByteReal", ncerr_not_opt, ncid, &
-!!$            varid)
-!!$    end if
-!!$
-!!$  end subroutine nf90_put_var_3D_EightByteReal
+  subroutine nf95_put_var_4D_EightByteReal(ncid, varid, values, start, &
+       count_nc, stride, map, ncerr)
+
+    use typesizes, only: EightByteReal
+    use netcdf, only: nf90_put_var
+    use handle_err_m, only: handle_err
+
+    integer, intent(in):: ncid, varid
+    real(kind = EightByteReal), intent(in):: values(:, :, :, :)
+    integer, dimension(:), optional, intent(in):: start, count_nc, stride, map
+    integer, intent(out), optional:: ncerr
+
+    ! Variable local to the procedure:
+    integer ncerr_not_opt
+
+    !-------------------
+
+    ncerr_not_opt = nf90_put_var(ncid, varid, values, start, count_nc, &
+         stride, map)
+    if (present(ncerr)) then
+       ncerr = ncerr_not_opt
+    else
+       call handle_err("nf95_put_var_4D_EightByteReal", ncerr_not_opt, ncid, &
+            varid)
+    end if
+
+  end subroutine nf95_put_var_4D_EightByteReal
 
 end module nf95_put_var_m
